<?php
/**
 * @version             $Id: pedigree.php 1.0 2011-01-05 HB $
 * @package             Joomla
 * @copyright   Copyright (C) 2011 Setter-anglais.fr/Tangor.net. All rights reserved.
 * @license             GNU/GPL, see LICENSE.php
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

jimport('joomla.event.plugin');
jimport('joomla.document.document');

require_once (JPATH_SITE . DS . 'components' . DS . 'com_content' . DS . 'helpers' . DS . 'route.php');

class plgContentPedigree extends JPlugin {
	
	function plgContentPedigree( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		
		$this->_params = new JParameter($plugin->params);

        $plugin =& JPluginHelper::getPlugin('content', 'pedigree');
        $pluginParams = new JParameter( $plugin->params );

		$this->Host = $pluginParams->get( 'pedigree_host', '' );
		$this->Langue = $pluginParams->get( 'pedigree_language', 'FR' );
		$this->CssStyle = $pluginParams->get( 'pedigree_css', '' );
	}

	public function onPrepareContent( &$article, &$params, $page=0 )
	{
		$this->MsgErr = '';
		$regex = '#{pedigree([^}]*)}#is';

//        $plugin =& JPluginHelper::getPlugin('content', 'pedigree');
//        $pluginParams = new JParameter( $plugin->params );

		$plugin_enabled = JPluginHelper::isEnabled('content', 'pedigree');
		if($plugin_enabled == "0") {
			$article->text = preg_replace($regex, '', $article->text);
		} else {
			if (preg_match_all($regex, $article->text, $matches, PREG_SET_ORDER) > 0) {
      			//$id = JRequest::getCmd('id');
      
				foreach ($matches as $match) {
   					$params0 = & JUtility::parseAttributes($match[1]);
//					$params0['id'] = (@$params0['id'])? $params0['id']:$pluginParams->get( 'id', '' );
					$id = $params0['id'];
					if (! ($id > 0) ) {
						$this->MsgErr = "Error parameter pedigree 'id'.";
					} else {
						$article->text = preg_replace($regex, $this->Pedigree($id), $article->text, 1);
					}
					unset($params0);
        		}
			}
		}

		// Print error messages
		if($this->MsgErr) {
				$this->MsgErr = str_replace('\\n', "\n", $this->MsgErr);
				$article->text = "<div style='border:2px solid black; padding: 10px; background-color: white; font-weight: bold; color: red;'>Pedigree error on this page:<br /><br />\n\n".$this->MsgErr."</div>" . $article->text;
		}
		
		// Update headers
		$this->AddHeader('style');

	}

	private function Pedigree($id)
	{
		$url = $this->Host . "/genealogie/arbre.php?id=$id&fn=pedigree&EMBED=UTF-8&HOST={$this->Host}&LANGUE={$this->Langue}";
		$text = file_get_contents($url);
//$text = $url . "<br>\r\n" . $text;
		return $text;
	}

	private function AddHeader($headertype)
	{
		$document 	= &JFactory::getDocument();
    	if($headertype=='style' && !isset($headers['style'])) {
    		$headers['style'] = 1;
    		$document->addStyleDeclaration( "/* Pedigree CSS */\n"
				. str_replace(array('<br />', '\[', '\]', '&nbsp;'), array("\n", '{', '}', ' '), $this->CssStyle."\n"));
    	}
	}
	
}

?>